Index: trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- trunk/sources/HeuristicLab 3.3.sln	(revision 3644)
+++ trunk/sources/HeuristicLab 3.3.sln	(revision 3645)
@@ -242,4 +242,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.MainForm.WindowsForms-3.3", "HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj", "{AB687BBE-1BFE-476B-906D-44237135431D}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.OneMax.Views-3.3", "HeuristicLab.Problems.OneMax.Views\3.3\HeuristicLab.Problems.OneMax.Views-3.3.csproj", "{4FE983A1-AAF8-4977-B9E2-52B3224510CB}"
 EndProject
 Global
@@ -1347,4 +1349,20 @@
 		{AB687BBE-1BFE-476B-906D-44237135431D}.Services|x86.ActiveCfg = Release|x86
 		{AB687BBE-1BFE-476B-906D-44237135431D}.Services|x86.Build.0 = Release|x86
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Debug|x64.ActiveCfg = Debug|x64
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Debug|x64.Build.0 = Debug|x64
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Debug|x86.ActiveCfg = Debug|x86
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Debug|x86.Build.0 = Debug|x86
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|Any CPU.Build.0 = Release|Any CPU
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|x64.ActiveCfg = Release|x64
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|x64.Build.0 = Release|x64
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|x86.ActiveCfg = Release|x86
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|x86.Build.0 = Release|x86
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Services|Any CPU.ActiveCfg = Release|x86
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Services|x64.ActiveCfg = Release|x86
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Services|x86.ActiveCfg = Release|x86
+		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Services|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: trunk/sources/HeuristicLab 3.3/Files.txt
===================================================================
--- trunk/sources/HeuristicLab 3.3/Files.txt	(revision 3644)
+++ trunk/sources/HeuristicLab 3.3/Files.txt	(revision 3645)
@@ -51,4 +51,5 @@
 HeuristicLab.Problems.Knapsack.Views\3.3:HeuristicLab.Problems.Knapsack.Views-3.3.dll
 HeuristicLab.Problems.OneMax\3.3:HeuristicLab.Problems.OneMax-3.3.dll
+HeuristicLab.Problems.OneMax.Views\3.3:HeuristicLab.Problems.OneMax.Views-3.3.dll
 HeuristicLab.Problems.TestFunctions\3.3:HeuristicLab.Problems.TestFunctions-3.3.dll
 HeuristicLab.Problems.TestFunctions.Views\3.3:HeuristicLab.Problems.TestFunctions.Views-3.3.dll
Index: trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLab.Problems.OneMax.Views-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLab.Problems.OneMax.Views-3.3.csproj	(revision 3645)
+++ trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLab.Problems.OneMax.Views-3.3.csproj	(revision 3645)
@@ -0,0 +1,182 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{4FE983A1-AAF8-4977-B9E2-52B3224510CB}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Problems.OneMax.Views</RootNamespace>
+    <AssemblyName>HeuristicLab.Problems.OneMax.Views-3.3</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Xml.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.DataSetExtensions">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="HeuristicLabProblemsOneMaxViewsPlugin.cs" />
+    <Compile Include="OneMaxSolutionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="OneMaxSolutionView.Designer.cs">
+      <DependentUpon>OneMaxSolutionView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="HeuristicLabProblemsOneMaxViewsPlugin.cs.frame" />
+    <None Include="Properties\AssemblyInfo.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
+      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
+      <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.2\HeuristicLab.Common.Resources-3.2.csproj">
+      <Project>{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}</Project>
+      <Name>HeuristicLab.Common.Resources-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
+      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
+      <Name>HeuristicLab.Core.Views-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
+      <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
+      <Name>HeuristicLab.Data-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.BinaryVectorEncoding\3.3\HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj">
+      <Project>{66D249C3-A01D-42A8-82A2-919BC8EC3D83}</Project>
+      <Name>HeuristicLab.Encodings.BinaryVectorEncoding-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
+      <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
+      <Name>HeuristicLab.MainForm.WindowsForms-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.MainForm\3.3\HeuristicLab.MainForm-3.3.csproj">
+      <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
+      <Name>HeuristicLab.MainForm-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization.Views\3.3\HeuristicLab.Optimization.Views-3.3.csproj">
+      <Project>{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}</Project>
+      <Name>HeuristicLab.Optimization.Views-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimizer\3.3\HeuristicLab.Optimizer-3.3.csproj">
+      <Project>{C664305E-497C-4533-A140-967DEDB05C19}</Project>
+      <Name>HeuristicLab.Optimizer-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
+      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
+      <Name>HeuristicLab.Persistence-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.OneMax\3.3\HeuristicLab.Problems.OneMax-3.3.csproj">
+      <Project>{F62BCD22-FB83-4444-9401-8031C2487A86}</Project>
+      <Name>HeuristicLab.Problems.OneMax-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="OneMaxSolutionView.resx">
+      <DependentUpon>OneMaxSolutionView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+SubWCRev "%25ProjectDir%25\" "%25ProjectDir%25\HeuristicLabProblemsOneMaxViewsPlugin.cs.frame" "%25ProjectDir%25\HeuristicLabProblemsOneMaxViewsPlugin.cs"</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLabProblemsOneMaxViewsPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLabProblemsOneMaxViewsPlugin.cs.frame	(revision 3645)
+++ trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLabProblemsOneMaxViewsPlugin.cs.frame	(revision 3645)
@@ -0,0 +1,45 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Problems.OneMax.Views {
+  /// <summary>
+  /// Plugin class for HeuristicLab.Problems.OneMax.Views plugin
+  /// </summary>
+  [Plugin("HeuristicLab.Problems.OneMax.Views", "3.3.0.$WCREV$")]
+  [PluginFile("HeuristicLab.Problems.OneMax.Views-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.2")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.BinaryVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.OneMax", "3.3")]
+  public class HeuristicLabProblemsKnapsackViewsPlugin : PluginBase {
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/OneMaxSolutionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/OneMaxSolutionView.cs	(revision 3645)
+++ trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/OneMaxSolutionView.cs	(revision 3645)
@@ -0,0 +1,72 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.Problems.OneMax;
+using HeuristicLab.Data;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.OneMax.Views {
+  /// <summary>
+  /// A view for a OneMax solution.
+  /// </summary>
+  [View("OneMax View")]
+  [Content(typeof(OneMaxSolution), true)]
+  public partial class OneMaxSolutionView : HeuristicLab.Core.Views.ItemView {
+    public new OneMaxSolution Content {
+      get { return (OneMaxSolution)base.Content; }
+      set { base.Content = value; }
+    }
+    
+    public OneMaxSolutionView() {
+      InitializeComponent();
+
+      qualityView.ReadOnly = true;
+      binaryVectorView.ReadOnly = true;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+
+      if (Content == null) {
+        qualityView.Content = null;
+        binaryVectorView.Content = null;
+      } else {
+        qualityView.ViewType = null;
+        qualityView.Content = Content.Quality;
+
+        binaryVectorView.ViewType = null;
+        binaryVectorView.Content = Content.BinaryVector;
+      }
+
+      SetEnabledStateOfControls();
+    }
+
+    private void SetEnabledStateOfControls() {
+      qualityView.Enabled = Content != null;
+      binaryVectorView.Enabled = Content != null;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/OnemaxSolutionView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/OnemaxSolutionView.Designer.cs	(revision 3645)
+++ trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/OnemaxSolutionView.Designer.cs	(revision 3645)
@@ -0,0 +1,143 @@
+﻿namespace HeuristicLab.Problems.OneMax.Views {
+  partial class OneMaxSolutionView {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.qualityView = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.splitContainer1 = new System.Windows.Forms.SplitContainer();
+      this.groupBox3 = new System.Windows.Forms.GroupBox();
+      this.binaryVectorView = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.groupBox4 = new System.Windows.Forms.GroupBox();
+      this.splitContainer1.Panel1.SuspendLayout();
+      this.splitContainer1.Panel2.SuspendLayout();
+      this.splitContainer1.SuspendLayout();
+      this.groupBox3.SuspendLayout();
+      this.groupBox4.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // qualityView
+      // 
+      this.qualityView.Caption = null;
+      this.qualityView.Content = null;
+      this.qualityView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.qualityView.Location = new System.Drawing.Point(3, 16);
+      this.qualityView.Name = "qualityView";
+      this.qualityView.ReadOnly = false;
+      this.qualityView.Size = new System.Drawing.Size(188, 30);
+      this.qualityView.TabIndex = 1;
+      this.qualityView.ViewType = null;
+      // 
+      // splitContainer1
+      // 
+      this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer1.FixedPanel = System.Windows.Forms.FixedPanel.Panel1;
+      this.splitContainer1.IsSplitterFixed = true;
+      this.splitContainer1.Location = new System.Drawing.Point(0, 0);
+      this.splitContainer1.Name = "splitContainer1";
+      this.splitContainer1.Orientation = System.Windows.Forms.Orientation.Horizontal;
+      // 
+      // splitContainer1.Panel1
+      // 
+      this.splitContainer1.Panel1.Controls.Add(this.groupBox3);
+      this.splitContainer1.Panel1MinSize = 30;
+      // 
+      // splitContainer1.Panel2
+      // 
+      this.splitContainer1.Panel2.Controls.Add(this.groupBox4);
+      this.splitContainer1.Panel2MinSize = 30;
+      this.splitContainer1.Size = new System.Drawing.Size(392, 265);
+      this.splitContainer1.TabIndex = 7;
+      // 
+      // groupBox3
+      // 
+      this.groupBox3.Controls.Add(this.qualityView);
+      this.groupBox3.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox3.Location = new System.Drawing.Point(0, 0);
+      this.groupBox3.Name = "groupBox3";
+      this.groupBox3.Size = new System.Drawing.Size(392, 50);
+      this.groupBox3.TabIndex = 6;
+      this.groupBox3.TabStop = false;
+      this.groupBox3.Text = "Quality";
+      // 
+      // qualityView
+      // 
+      this.qualityView.Caption = null;
+      this.qualityView.Content = null;
+      this.qualityView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.qualityView.Location = new System.Drawing.Point(3, 16);
+      this.qualityView.Name = "qualityView";
+      this.qualityView.ReadOnly = false;
+      this.qualityView.Size = new System.Drawing.Size(386, 31);
+      this.qualityView.TabIndex = 1;
+      this.qualityView.ViewType = null;
+      // 
+      // groupBox4
+      // 
+      this.groupBox4.Controls.Add(this.binaryVectorView);
+      this.groupBox4.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox4.Location = new System.Drawing.Point(0, 0);
+      this.groupBox4.Name = "groupBox4";
+      this.groupBox4.Size = new System.Drawing.Size(392, 211);
+      this.groupBox4.TabIndex = 6;
+      this.groupBox4.TabStop = false;
+      this.groupBox4.Text = "Binary vector";
+      // 
+      // binaryVectorView
+      // 
+      this.binaryVectorView.Caption = null;
+      this.binaryVectorView.Content = null;
+      this.binaryVectorView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.binaryVectorView.Location = new System.Drawing.Point(3, 16);
+      this.binaryVectorView.Name = "binaryVectorView";
+      this.binaryVectorView.ReadOnly = false;
+      this.binaryVectorView.Size = new System.Drawing.Size(386, 192);
+      this.binaryVectorView.TabIndex = 1;
+      this.binaryVectorView.ViewType = null;
+      // 
+      // OneMaxSolutionView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.Controls.Add(this.splitContainer1);
+      this.Name = "OneMaxSolutionView";
+      this.Size = new System.Drawing.Size(392, 265);
+      this.splitContainer1.Panel1.ResumeLayout(false);
+      this.splitContainer1.Panel2.ResumeLayout(false);
+      this.splitContainer1.ResumeLayout(false);
+      this.groupBox3.ResumeLayout(false);
+      this.groupBox4.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.SplitContainer splitContainer1;
+    private System.Windows.Forms.GroupBox groupBox4;
+    protected HeuristicLab.MainForm.WindowsForms.ViewHost qualityView;
+    private System.Windows.Forms.GroupBox groupBox3;
+    protected HeuristicLab.MainForm.WindowsForms.ViewHost binaryVectorView;
+
+
+
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/Properties/AssemblyInfo.frame	(revision 3645)
+++ trunk/sources/HeuristicLab.Problems.OneMax.Views/3.3/Properties/AssemblyInfo.frame	(revision 3645)
@@ -0,0 +1,55 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Problems.OneMax.Views")]
+[assembly: AssemblyDescription("Views of the HeuristicLab OneMax classes")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2010 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("02E47AF8-4DB5-4a77-8E62-3CED7A1EC29A")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.0.$WCREV$")]